<?php
/**
 * @package helpdesk
 * Copyright OSI 2005. Licensed under GPL version 2.
 * $Id: core.php,v 1.1 2006/01/17 19:55:10 fgm Exp $
 */

abstract class helpdeskObject
  {
  /**
   * initialize existing class instance from passed values
   *
   * @param object $node Node from which data is taken (always nid, the rest depending on $fromDB)
   * @param boolean $fromDB Is data to be taken from the DB or from $node ?
   * @return void
   */
  abstract function init($node, $fromDB);
  
  /**
   * implement the equivalent of hook_view for the class, but return the produced HTML
   * instead of modifying the node
   * @return string HTML for the class representation
   *
   */
  abstract function view();
  
  /**
   * implement the equivalent of hook_form for the class
   * @param object $node
   * @return string HTML for the class edition form
   *
   */
  abstract function form();

  /**
   * implementation of hook_node_name for HD content objects
   * @return string
   */
  function node_name()
    {

    $className = get_class($this);
    if (HELPDESKDEBUGALLFUNCTIONS == TRUE)
      { echo "<pre>HD $className::node_name ()</pre>" ; }
      
    switch ($className)
      {
      case 'helpdeskContract':  $ret = HELPDESKNODECONTRACT ; break ;
      case 'helpdeskTicket':    $ret = HELPDESKNODETICKET   ; break ;
      case 'helpdeskFollowup':  $ret = HELPDESKNODEFOLLOWUP ; break ;
      default:
        die("node_name method invoked for instance of class $className, should not happen.") ;
      }
    return $ret;
    }
  }
  
?>
